add running profiler in python
[doctor.git] / tests / run.sh
index 206f6a4..e1875e0 100755 (executable)
@@ -17,51 +17,43 @@ IMAGE_URL=https://launchpad.net/cirros/trunk/0.3.0/+download/cirros-0.3.0-x86_64
 IMAGE_NAME=${IMAGE_NAME:-cirros}
 IMAGE_FILE="${IMAGE_NAME}.img"
 IMAGE_FORMAT=qcow2
-VM_NAME=doctor_vm1
+VM_BASENAME=doctor_vm
 VM_FLAVOR=m1.tiny
-ALARM_NAME=doctor_alarm1
-INSPECTOR_PORT=12345
+#if VM_COUNT set, use that instead
+VM_COUNT=${VM_COUNT:-1}
+NET_NAME=doctor_net
+NET_CIDR=192.168.168.0/24
+ALARM_BASENAME=doctor_alarm
 CONSUMER_PORT=12346
 DOCTOR_USER=doctor
 DOCTOR_PW=doctor
 DOCTOR_PROJECT=doctor
-#TODO: change back to `_member_` when JIRA DOCTOR-55 is done
-DOCTOR_ROLE=admin
-PROFILER_TYPE=${PROFILER_TYPE:-none}
+DOCTOR_ROLE=_member_
+PROFILER_TYPE=${PROFILER_TYPE:-poc}
+PYTHON_ENABLE=${PYTHON_ENABLE:-false}
 
 TOP_DIR=$(cd $(dirname "$0") && pwd)
 
-ssh_opts="-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
 as_doctor_user="--os-username $DOCTOR_USER --os-password $DOCTOR_PW
-                --os-tenant-name $DOCTOR_PROJECT"
+                --os-project-name $DOCTOR_PROJECT --os-tenant-name $DOCTOR_PROJECT"
+# NOTE: ceilometer command still requires '--os-tenant-name'.
+#ceilometer="ceilometer ${as_doctor_user/--os-project-name/--os-tenant-name}"
+ceilometer="ceilometer $as_doctor_user"
+as_admin_user="--os-username admin --os-project-name $DOCTOR_PROJECT
+               --os-tenant-name $DOCTOR_PROJECT"
 
 
 # Functions
 
 get_compute_host_info() {
-    # get computer host info which VM boot in
-    COMPUTE_HOST=$(openstack $as_doctor_user server show $VM_NAME |
-                   grep "OS-EXT-SRV-ATTR:host" | awk '{ print $4 }')
+    # get computer host info which first VM boot in as admin user
+    COMPUTE_HOST=$(openstack $as_admin_user server show ${VM_BASENAME}1 |
+                   grep "OS-EXT-SRV-ATTR:host " | awk '{ print $4 }')
     compute_host_in_undercloud=${COMPUTE_HOST%%.*}
     die_if_not_set $LINENO COMPUTE_HOST "Failed to get compute hostname"
 
-    if is_installer apex; then
-        COMPUTE_USER=${COMPUTE_USER:-heat-admin}
-        COMPUTE_IP=$(sudo ssh $ssh_opts $INSTALLER_IP \
-             "source stackrc; \
-             nova show $compute_host_in_undercloud \
-             | awk '/ ctlplane network /{print \$5}'")
-    elif is_installer fuel; then
-        COMPUTE_USER=${COMPUTE_USER:-root}
-        node_id=$(echo $compute_host_in_undercloud | cut -d "-" -f 2)
-        COMPUTE_IP=$(sshpass -p r00tme ssh 2>/dev/null $ssh_opts root@${INSTALLER_IP} \
-             "fuel node|awk -F '|' -v id=$node_id '{if (\$1 == id) print \$5}' |xargs")
-    elif is_installer local; then
-        COMPUTE_USER=${COMPUTE_USER:-$(whoami)}
-        COMPUTE_IP=$(getent hosts "$COMPUTE_HOST" | awk '{ print $1 }')
-    fi
+    get_compute_ip_from_hostname $COMPUTE_HOST
 
-    die_if_not_set $LINENO COMPUTE_IP "Could not resolve $COMPUTE_HOST. Either manually set COMPUTE_IP or enable DNS resolution."
     echo "COMPUTE_HOST=$COMPUTE_HOST"
     echo "COMPUTE_IP=$COMPUTE_IP"
 
@@ -78,7 +70,9 @@ get_compute_host_info() {
     fi
 }
 
-get_consumer_ip() {
+# TODO(r-mibu): update this function to support consumer instance
+#               and migrate this function into installer lib
+get_consumer_ip___to_be_removed() {
     local get_consumer_command="ip route get $COMPUTE_IP | awk '/ src /{print \$NF}'"
     if is_installer apex; then
         CONSUMER_IP=$(sudo ssh $ssh_opts root@$INSTALLER_IP \
@@ -116,53 +110,106 @@ register_image() {
 
 create_test_user() {
     openstack project list | grep -q " $DOCTOR_PROJECT " || {
-        openstack project create "$DOCTOR_PROJECT"
+        openstack project create --description "Doctor Project" \
+                                 "$DOCTOR_PROJECT"
     }
     openstack user list | grep -q " $DOCTOR_USER " || {
         openstack user create "$DOCTOR_USER" --password "$DOCTOR_PW" \
                               --project "$DOCTOR_PROJECT"
     }
-    openstack user role list "$DOCTOR_USER" --project "$DOCTOR_PROJECT" \
-    | grep -q " $DOCTOR_ROLE " || {
+    openstack role show "$DOCTOR_ROLE" | grep -q " $DOCTOR_ROLE " || {
+        openstack role create "$DOCTOR_ROLE"
+    }
+    openstack role assignment list --user "$DOCTOR_USER" \
+    --project "$DOCTOR_PROJECT" --names | grep -q " $DOCTOR_ROLE " || {
         openstack role add "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
                            --project "$DOCTOR_PROJECT"
     }
+    openstack role assignment list --user admin --project "$DOCTOR_PROJECT" \
+    --names | grep -q " admin " || {
+        openstack role add admin --user admin --project "$DOCTOR_PROJECT"
+    }
+    # tojuvone: openstack quota show is broken and have to use nova
+    # https://bugs.launchpad.net/manila/+bug/1652118
+    # Note! while it is encouraged to use openstack client it has proven
+    # quite buggy.
+    # QUOTA=$(openstack quota show $DOCTOR_PROJECT)
+    DOCTOR_QUOTA=$(nova quota-show --tenant $DOCTOR_PROJECT)
+    # We make sure that quota allows number of instances and cores
+    OLD_INSTANCE_QUOTA=$(echo "${DOCTOR_QUOTA}" | grep " instances " | \
+                         awk '{print $4}')
+    if [ $OLD_INSTANCE_QUOTA -lt $VM_COUNT ]; then
+        openstack quota set --instances $VM_COUNT \
+                  $DOCTOR_USER
+    fi
+    OLD_CORES_QUOTA=$(echo "${DOCTOR_QUOTA}" | grep " cores " | \
+                      awk '{print $4}')
+    if [ $OLD_CORES_QUOTA -lt $VM_COUNT ]; then
+        openstack quota set --cores $VM_COUNT \
+                  $DOCTOR_USER
+    fi
+}
+
+remove_test_user() {
+    openstack project list | grep -q " $DOCTOR_PROJECT " && {
+        openstack role assignment list --user admin \
+        --project "$DOCTOR_PROJECT" --names | grep -q " admin " && {
+            openstack role remove admin --user admin --project "$DOCTOR_PROJECT"
+        }
+        openstack user list | grep -q " $DOCTOR_USER " && {
+            openstack role assignment list --user "$DOCTOR_USER" \
+            --project "$DOCTOR_PROJECT" --names | grep -q " $DOCTOR_ROLE " && {
+                openstack role remove "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
+                --project "$DOCTOR_PROJECT"
+            }
+            openstack user delete "$DOCTOR_USER"
+        }
+        openstack project delete "$DOCTOR_PROJECT"
+    }
 }
 
 boot_vm() {
     # test VM done with test user, so can test non-admin
-    openstack $as_doctor_user server list | grep -q " $VM_NAME " && return 0
-    openstack $as_doctor_user server create --flavor "$VM_FLAVOR" \
-                            --image "$IMAGE_NAME" \
-                            "$VM_NAME"
+
+    if ! openstack $as_doctor_user network show $NET_NAME; then
+        openstack $as_doctor_user network create $NET_NAME
+    fi
+    if ! openstack $as_doctor_user subnet show $NET_NAME; then
+        openstack $as_doctor_user subnet create $NET_NAME \
+            --network $NET_NAME --subnet-range $NET_CIDR --no-dhcp
+    fi
+    net_id=$(openstack $as_doctor_user network show $NET_NAME -f value -c id)
+
+    servers=$(openstack $as_doctor_user server list)
+    for i in `seq $VM_COUNT`; do
+        echo "${servers}" | grep -q " $VM_BASENAME$i " && continue
+        openstack $as_doctor_user server create --flavor "$VM_FLAVOR" \
+            --image "$IMAGE_NAME" --nic net-id=$net_id "$VM_BASENAME$i"
+    done
     sleep 1
 }
 
 create_alarm() {
     # get vm_id as test user
-    ceilometer $as_doctor_user alarm-list | grep -q " $ALARM_NAME " && return 0
-    vm_id=$(openstack $as_doctor_user server list | grep " $VM_NAME " | awk '{print $2}')
-    # TODO(r-mibu): change notification endpoint from localhost to the consumer
-    # IP address (functest container).
-    ceilometer $as_doctor_user alarm-event-create --name "$ALARM_NAME" \
-        --alarm-action "http://localhost:$CONSUMER_PORT/failure" \
-        --description "VM failure" \
-        --enabled True \
-        --repeat-actions False \
-        --severity "moderate" \
-        --event-type compute.instance.update \
-        -q "traits.state=string::error; traits.instance_id=string::$vm_id"
-}
-
-start_monitor() {
-    pgrep -f "python monitor.py" && return 0
-    sudo -E python monitor.py "$COMPUTE_HOST" "$COMPUTE_IP" "$INSPECTOR_TYPE" \
-        "http://127.0.0.1:$INSPECTOR_PORT/events" > monitor.log 2>&1 &
-}
-
-stop_monitor() {
-    pgrep -f "python monitor.py" || return 0
-    sudo kill $(pgrep -f "python monitor.py")
+    alarm_list=$($ceilometer alarm-list)
+    vms=$(openstack $as_doctor_user server list)
+    for i in `seq $VM_COUNT`; do
+        echo "${alarm_list}" | grep -q " $ALARM_BASENAME$i " || {
+            vm_id=$(echo "${vms}" | grep " $VM_BASENAME$i " | awk '{print $2}')
+            # TODO(r-mibu): change notification endpoint from localhost to the
+            # consumer. IP address (functest container).
+            $ceilometer alarm-event-create \
+                       --name "$ALARM_BASENAME$i" \
+                       --alarm-action "http://localhost:$CONSUMER_PORT/failure" \
+                       --description "VM failure" \
+                       --enabled True \
+                       --repeat-actions False \
+                       --severity "moderate" \
+                       --event-type compute.instance.update \
+                       -q "traits.state=string::error; \
+                       traits.instance_id=string::$vm_id"
+            }
+     done
 }
 
 start_consumer() {
@@ -173,17 +220,6 @@ start_consumer() {
     # avoid some network problems dpends on infra and installers.
     # This tunnel will be terminated by stop_consumer() or after 10 mins passed.
     if ! is_installer local; then
-        if is_installer apex; then
-            CONTROLLER_IPS=$(sudo ssh $ssh_opts $INSTALLER_IP \
-                             "source stackrc; \
-                             nova list | grep ' overcloud-controller-[0-9] ' \
-                             | sed -e 's/^.*ctlplane=//' -e 's/ *|\$//'")
-        elif is_installer fuel; then
-            CONTROLLER_IPS=$(sshpass -p r00tme ssh 2>/dev/null $ssh_opts root@${INSTALLER_IP} \
-                            "fuel node | grep controller | cut -d '|' -f 5|xargs")
-        fi
-
-        die_if_not_set $LINENO CONTROLLER_IPS "Could not get CONTROLLER_IPS."
         for ip in $CONTROLLER_IPS
         do
             forward_rule="-R $CONSUMER_PORT:localhost:$CONSUMER_PORT"
@@ -214,18 +250,31 @@ wait_for_vm_launch() {
     count=0
     while [[ ${count} -lt 60 ]]
     do
-        state=$(openstack $as_doctor_user server list | grep " $VM_NAME " | awk '{print $6}')
-        if [[ "$state" == "ACTIVE" ]]; then
-            # NOTE(cgoncalves): sleeping for a bit to stabilize
-            # See python-openstackclient/functional/tests/compute/v2/test_server.py:wait_for_status
-            sleep 5
+        active_count=0
+        vms=$(openstack $as_doctor_user server list)
+        for i in `seq $VM_COUNT`; do
+            state=$(echo "${vms}" | grep " $VM_BASENAME$i " | awk '{print $6}')
+            if [[ "$state" == "ACTIVE" ]]; then
+                active_count=$(($active_count+1))
+            elif [[ "$state" == "ERROR" ]]; then
+                die $LINENO "vm state $VM_BASENAME$i is ERROR"
+            else
+                #This VM not yet active
+                count=$(($count+1))
+                sleep 5
+                continue
+            fi
+        done
+        [[ $active_count -eq $VM_COUNT ]] && {
+            echo "get computer host info..."
+            get_compute_host_info
+            VMS_ON_FAILED_HOST=$(openstack $as_doctor_user server list --host \
+                         $COMPUTE_HOST | grep " ${VM_BASENAME}" |  wc -l)
             return 0
-        fi
-        if [[ "$state" == "ERROR" ]]; then
-            die $LINENO "vm state is ERROR"
-        fi
+        }
+        #Not all VMs active
         count=$(($count+1))
-        sleep 1
+        sleep 5
     done
     die $LINENO "Time out while waiting for VM launch"
 }
@@ -234,53 +283,51 @@ inject_failure() {
     echo "disabling network of compute host [$COMPUTE_HOST] for 3 mins..."
     cat > disable_network.sh << 'END_TXT'
 #!/bin/bash -x
-dev=$(sudo ip a | awk '/ @COMPUTE_IP@\//{print $7}')
 sleep 1
+if [ -n "@INTERFACE_NAME@" ]; then
+    dev=@INTERFACE_NAME@
+else
+    dev=$(sudo ip a | awk '/ @COMPUTE_IP@\//{print $NF}')
+fi
 sudo ip link set $dev down
-echo "doctor set host down at" $(date "+%s.%N")
+echo "doctor set link down at" $(date "+%s.%N")
 sleep 180
 sudo ip link set $dev up
 sleep 1
 END_TXT
     sed -i -e "s/@COMPUTE_IP@/$COMPUTE_IP/" disable_network.sh
+    sed -i -e "s/@INTERFACE_NAME@/$INTERFACE_NAME/" disable_network.sh
     chmod +x disable_network.sh
     scp $ssh_opts_cpu disable_network.sh "$COMPUTE_USER@$COMPUTE_IP:"
     ssh $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP" 'nohup ./disable_network.sh > disable_network.log 2>&1 &'
+    # use host time to get rid of potential time sync deviation between nodes
+    triggered=$(date "+%s.%N")
 }
 
-profile_performance_poc() {
-    triggered=$(grep "^doctor set host down at" disable_network.log |\
-                sed -e "s/^.* at //")
-    vmdown=$(grep "doctor mark vm.* error at" inspector.log |tail -n 1 |\
-               sed -e "s/^.* at //")
-    hostdown=$(grep "doctor mark host.* down at" inspector.log |\
-               sed -e "s/^.* at //")
-
-    #calculate the relative interval to triggered(T00)
-    export DOCTOR_PROFILER_T00=0
-    export DOCTOR_PROFILER_T01=$(echo "($detected-$triggered)*1000/1" |bc)
-    export DOCTOR_PROFILER_T03=$(echo "($vmdown-$triggered)*1000/1" |bc)
-    export DOCTOR_PROFILER_T04=$(echo "($hostdown-$triggered)*1000/1" |bc)
-    export DOCTOR_PROFILER_T09=$(echo "($notified-$triggered)*1000/1" |bc)
-
-    python profiler-poc.py
+wait_consumer() {
+    local interval=1
+    local rounds=$(($1 / $interval))
+    for i in `seq $rounds`; do
+        notified_count=$(grep "doctor consumer notified at" consumer.log | wc -l)
+        if [[ $notified_count -eq  $VMS_ON_FAILED_HOST ]]; then
+            return 0
+        fi
+        sleep $interval
+    done
+    die $LINENO "Consumer hasn't received fault notification."
 }
 
 calculate_notification_time() {
-    if ! grep -q "doctor consumer notified at" consumer.log ; then
-        die $LINENO "Consumer hasn't received fault notification."
-    fi
-
+    wait_consumer 60
     #keep 'at' as the last keyword just before the value, and
     #use regex to get value instead of the fixed column
+    if [ ! -f monitor.log ]; then
+        scp $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP:monitor.log" .
+    fi
     detected=$(grep "doctor monitor detected at" monitor.log |\
-               sed -e "s/^.* at //")
+               sed -e "s/^.* at //" | tail -1)
     notified=$(grep "doctor consumer notified at" consumer.log |\
-               sed -e "s/^.* at //")
-
-    if [[ "$PROFILER_TYPE" == "poc" ]]; then
-        profile_performance_poc
-    fi
+               sed -e "s/^.* at //" | tail -1)
 
     echo "$notified $detected" | \
         awk '{
@@ -291,37 +338,119 @@ calculate_notification_time() {
 }
 
 check_host_status() {
+    # Check host related to first Doctor VM is in wanted state
+    # $1    Expected state
+    # $2    Seconds to wait to have wanted state
     expected_state=$1
-
-    host_status_line=$(openstack $as_doctor_user --os-compute-api-version 2.16 \
-                       server show $VM_NAME | grep "host_status")
-    host_status=$(echo $host_status_line | awk '{print $4}')
-    die_if_not_set $LINENO host_status "host_status not reported by: nova show $VM_NAME"
+    local interval=5
+    local rounds=$(($2 / $interval))
+    for i in `seq $rounds`; do
+        host_status_line=$(openstack $as_doctor_user --os-compute-api-version \
+                           2.16 server show ${VM_BASENAME}1 | grep "host_status")
+        host_status=$(echo $host_status_line | awk '{print $4}')
+        die_if_not_set $LINENO host_status "host_status not reported by: nova show ${VM_BASENAME}1"
+        if [[ "$expected_state" =~ "$host_status" ]] ; then
+            echo "${VM_BASENAME}1 showing host_status: $host_status"
+            return 0
+        else
+            sleep $interval
+        fi
+    done
     if [[ "$expected_state" =~ "$host_status" ]] ; then
-        echo "$VM_NAME showing host_status: $host_status"
+        echo "${VM_BASENAME}1 showing host_status: $host_status"
     else
-        die $LINENO "host_status:$host_status not equal to expected_state: $expected_state"
+        die $LINENO  "host_status:$host_status not equal to expected_state: $expected_state"
+    fi
+}
+
+unset_forced_down_hosts() {
+    # for debug
+    openstack compute service list --service nova-compute
+
+    downed_computes=$(openstack compute service list --service nova-compute \
+                      -f value -c Host -c State | grep ' down$' \
+                      | sed -e 's/ *down$//')
+    echo "downed_computes: $downed_computes"
+    for host in $downed_computes
+    do
+        # TODO(r-mibu): use openstack client
+        #openstack compute service set --up $host nova-compute
+        nova service-force-down --unset $host nova-compute
+    done
+
+    echo "waiting disabled compute host back to be enabled..."
+    wait_until 'openstack compute service list --service nova-compute
+                -f value -c State | grep -q down' 240 5
+
+    for host in $downed_computes
+    do
+        # TODO(r-mibu): improve 'get_compute_ip_from_hostname'
+        get_compute_ip_from_hostname $host
+        wait_until "! ping -c 1 $COMPUTE_IP" 120 5
+    done
+}
+
+collect_logs() {
+    if [[ -n "$COMPUTE_IP" ]];then
+        scp $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP:disable_network.log" .
+    fi
+
+    # TODO(yujunz) collect other logs, e.g. nova, aodh
+}
+
+run_profiler() {
+    if [[ "$PROFILER_TYPE" == "poc" ]]; then
+        linkdown=$(grep "doctor set link down at " disable_network.log |\
+                  sed -e "s/^.* at //")
+        vmdown=$(grep "doctor mark vm.* error at" inspector.log |tail -n 1 |\
+                 sed -e "s/^.* at //")
+        hostdown=$(grep "doctor mark host.* down at" inspector.log |\
+                 sed -e "s/^.* at //")
+
+        # TODO(yujunz) check the actual delay to verify time sync status
+        # expected ~1s delay from $trigger to $linkdown
+        relative_start=${linkdown}
+        export DOCTOR_PROFILER_T00=$(python -c \
+          "print(int(($linkdown-$relative_start)*1000))")
+        export DOCTOR_PROFILER_T01=$(python -c \
+          "print(int(($detected-$relative_start)*1000))")
+        export DOCTOR_PROFILER_T03=$(python -c \
+          "print(int(($vmdown-$relative_start)*1000))")
+        export DOCTOR_PROFILER_T04=$(python -c \
+          "print(int(($hostdown-$relative_start)*1000))")
+        export DOCTOR_PROFILER_T09=$(python -c \
+          "print(int(($notified-$relative_start)*1000))")
+
+        python profiler_poc.py > doctor_profiler.log 2>&1
     fi
 }
 
 cleanup() {
     set +e
     echo "cleanup..."
-    stop_monitor
     stop_inspector
     stop_consumer
 
-    echo "waiting disabled compute host back to be enabled..."
-    python ./nova_force_down.py "$COMPUTE_HOST" --unset
-    sleep 240
-    check_host_status "UP"
-    scp $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP:disable_network.log" .
+    unset_forced_down_hosts
+    stop_monitor
+    collect_logs
 
-    openstack $as_doctor_user server list | grep -q " $VM_NAME " && openstack $as_doctor_user server delete "$VM_NAME"
-    sleep 1
-    alarm_id=$(ceilometer $as_doctor_user alarm-list | grep " $ALARM_NAME " | awk '{print $2}')
+    vms=$(openstack $as_doctor_user server list)
+    vmstodel=""
+    for i in `seq $VM_COUNT`; do
+        $(echo "${vms}" | grep -q " $VM_BASENAME$i ") &&
+        vmstodel+=" $VM_BASENAME$i"
+    done
+    [[ $vmstodel ]] && openstack $as_doctor_user server delete $vmstodel
+    alarm_list=$($ceilometer alarm-list)
+    for i in `seq $VM_COUNT`; do
+        alarm_id=$(echo "${alarm_list}" | grep " $ALARM_BASENAME$i " |
+                   awk '{print $2}')
+        [ -n "$alarm_id" ] && $ceilometer alarm-delete "$alarm_id"
+    done
+    openstack $as_doctor_user subnet delete $NET_NAME
     sleep 1
-    [ -n "$alarm_id" ] && ceilometer $as_doctor_user alarm-delete "$alarm_id"
+    openstack $as_doctor_user network delete $NET_NAME
     sleep 1
 
     image_id=$(openstack image list | grep " $IMAGE_NAME " | awk '{print $2}')
@@ -330,24 +459,59 @@ cleanup() {
     if [[ "$use_existing_image" == false ]] ; then
         [ -n "$image_id" ] && openstack image delete "$image_id"
     fi
-    openstack role remove "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
-                              --project "$DOCTOR_PROJECT"
-    openstack project delete "$DOCTOR_PROJECT"
-    openstack user delete "$DOCTOR_USER"
+
+    remove_test_user
 
     cleanup_installer
     cleanup_inspector
+    cleanup_monitor
+
+    # NOTE: Temporal log printer.
+    for f in $(find . -name '*.log')
+    do
+        echo
+        echo "[$f]"
+        sed -e 's/^/ | /' $f
+        echo
+    done
+}
+
+setup_python_packages() {
+    sudo pip install flask==0.10.1
+    command -v openstack || sudo pip install python-openstackclient==2.3.0
+    command -v ceilometer || sudo pip install python-ceilometerclient==2.6.2
+    command -v congress || sudo pip install python-congressclient==1.5.0
 }
 
 # Main process
 
+if [[ $PYTHON_ENABLE == [Tt]rue ]]; then
+    which tox || sudo pip install tox
+    if [ -f /usr/bin/apt-get ]; then
+        sudo apt-get install -y python3-dev
+    elif [ -f /usr/bin/yum ] ; then
+        sudo yum install -y python3-devel
+    fi
+
+    cd $TOP_DIR
+    echo "executing tox..."
+    tox
+    exit $?
+fi
+
 echo "Note: doctor/tests/run.sh has been executed."
+git log --oneline -1 || true   # ignore even you don't have git installed
 
 trap cleanup EXIT
 
+setup_python_packages
+
 source $TOP_DIR/functions-common
 source $TOP_DIR/lib/installer
 source $TOP_DIR/lib/inspector
+source $TOP_DIR/lib/monitor
+
+rm -f *.log
 
 setup_installer
 
@@ -362,9 +526,6 @@ echo "creating VM..."
 boot_vm
 wait_for_vm_launch
 
-echo "get computer host info..."
-get_compute_host_info
-
 echo "creating alarm..."
 #TODO: change back to use, network problems depends on infra and installers
 #get_consumer_ip
@@ -378,9 +539,11 @@ start_consumer
 sleep 60
 echo "injecting host failure..."
 inject_failure
-sleep 60
 
-check_host_status "(DOWN|UNKNOWN)"
+check_host_status "(DOWN|UNKNOWN)" 60
+unset_forced_down_hosts
 calculate_notification_time
+collect_logs
+run_profiler
 
 echo "done"